using System;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Experimental.Rendering;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using MeshVR;
using MVR.FileManagementSecure;
using AssetBundles;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;

namespace Stopper {
	public class AlternativeFuta : MVRScript {
	
	DAZCharacter newCharacter;
	GameObject newCharacterContainer;
	
	GameObject maleCharacterContainer;
	
	GameObject femaleSkinsContainer;
	
	GameObject femaleSkinsPrefab;
	GameObject maleSkinsPrefab;
	
	DAZCharacterSelector characterSelector;
	
	DAZCharacterRun characterRun;
	
	DAZMergedSkinV2 skin;
		
	DAZMergedMesh mergedMesh;
	
	DAZMesh genMesh;
	
	DAZMergedSkinV2 maleSkin;
	DAZMergedMesh maleMergedMesh;
	
	GameObject femaleSkinBase;
	GameObject maleSkinBase;
	
	DAZBone gen1Bone;
	DAZBone gen2Bone;
	DAZBone gen3Bone;
	
	// UI Stuff
	
	GameObject UIContainer; 
	Material genMaterial;
	int genMaterialIndex;
	DAZCharacterMaterialOptions genMaterialOptions;
	
	GameObject materialUIPrefab;
	MVRScriptUI scriptUI;
	
	float genBoneYOffset = 0.029f;
	float genBoneZOffset = -0.017f;
	
	public class DAZSkinV2Wrapper : DAZSkinV2 {
		public void Copy(DAZSkinV2 other){
			this.sceneGeometryId = other.sceneGeometryId;
			this._numBones = other.numBones;
			this.nodes = other.nodes;
		}
	}
	
	
	public class MaterialOptionsWrapper : DAZCharacterMaterialOptions {
		public void SetParams(){
			this.SetAllParameters();
		}
	}

	public override void Init() {
		
		
		foreach (GameObject go in Resources.FindObjectsOfTypeAll(typeof(GameObject)) as GameObject[]){
			if(go.name =="FemaleCharactersPrefab"){
				femaleSkinsPrefab = go;
			}
			
			if(go.name =="MaleCharactersPrefab"){
				maleSkinsPrefab = go;
			}
		}
	
		
		foreach(GameObject go in GetAllChildren(containingAtom.gameObject)){
			if(go.name.Contains("FemaleCharactersPrefab")){
				femaleSkinsContainer = go;
			}
		}
		
		foreach(GameObject go in GetAllChildren(femaleSkinsPrefab)){
			if(go.name == "rensimone"){
				femaleSkinBase = go;
			}
		}
		
		foreach(GameObject go in GetAllChildren(maleSkinsPrefab)){
			if(go.name == "FutaSimone"){
				maleSkinBase = go;
			}
		}
		
		characterRun = containingAtom.GetComponentInChildren<DAZCharacterRun>();
		
		
		gen1Bone = characterRun.bones.GetDAZBone("Gen1");
		gen2Bone = characterRun.bones.GetDAZBone("Gen2");
		gen3Bone = characterRun.bones.GetDAZBone("Gen3");
		
		StartCoroutine("TransPlant");
	}
	
	private IEnumerator TransPlant(){
		
		characterSelector = containingAtom.GetComponentInChildren<DAZCharacterSelector>();
		
		maleCharacterContainer = UnityEngine.Object.Instantiate<GameObject>(maleSkinBase);
		maleCharacterContainer.SetActive(true);
		
		DAZMergedSkinV2 maleMergedSkin = null;
		while(maleMergedSkin == null){
			maleMergedSkin = maleCharacterContainer.GetComponentInChildren<DAZMergedSkinV2>();
			yield return null;
		}
		maleCharacterContainer.SetActive(false);
		maleMergedMesh = (maleMergedSkin.dazMesh as DAZMergedMesh);
			
	
		newCharacterContainer = UnityEngine.Object.Instantiate<GameObject>(femaleSkinBase);


		newCharacterContainer = UnityEngine.Object.Instantiate<GameObject>(femaleSkinBase);
		newCharacterContainer.SetActive(false);
		newCharacterContainer.name = "FutaSkin";
		
		newCharacter = newCharacterContainer.GetComponentInChildren<DAZCharacter>();
		newCharacterContainer.transform.parent = femaleSkinsContainer.transform;
	
		newCharacter.rootBonesForSkinning = characterSelector.rootBones;
		newCharacter.onLoadedHandlers = () => {
			skin = newCharacterContainer.GetComponentInChildren<DAZMergedSkinV2>();	
			
			mergedMesh = (skin.dazMesh as DAZMergedMesh);
			
			genMesh = mergedMesh.gameObject.AddComponent<DAZMesh>();
			
			genMesh.LoadFromBinaryFile($"{GetPluginPath(this,containingAtom)}/male_gen_dazmesh");
			
			for(int i = 0; i < genMesh.baseVertices.Length; i++){
				genMesh.baseVertices[i].y += genBoneYOffset;
				genMesh.baseVertices[i].z += genBoneZOffset;
				
			}
			for(int i = 0; i < genMesh.UVVertices.Length; i++){
				genMesh.UVVertices[i].y += genBoneYOffset;
				genMesh.UVVertices[i].z += genBoneZOffset;
			}
			
			
			genMesh.meshGraft = new DAZMeshGraft();
			genMesh.meshGraft.vertexPairs = new DAZMeshGraftVertexPair[0];
			genMesh.meshGraft.hiddenPolys = new int[0];
			genMesh.graftTo = mergedMesh.targetMesh;
			
			genMesh.Init();
		
			mergedMesh.Merge();

			DAZSkinV2 maleGenSkin = null;
			foreach(var skinv2 in maleCharacterContainer.GetComponentsInChildren<DAZSkinV2>()){
				if(skinv2.dazMesh == maleMergedMesh.graftMesh){
					maleGenSkin = skinv2;
				}
			}
			DAZSkinV2Wrapper genSkinv2 = mergedMesh.gameObject.AddComponent<DAZSkinV2Wrapper>();
			genSkinv2.Copy(maleGenSkin);
			
			skin.Merge();
	
	
			
			Material[] originalMaterials = skin.GPUmaterials;
			skin.CopyMaterials();
			for (int i = 0; i < skin.dazMesh.materials.Length-1; i++)	{
				if(i < originalMaterials.Length){
					skin.GPUmaterials[i] = originalMaterials[i];
				} else if (skin.GPUmaterials[i].name == "Genitalia") {
					genMaterial = new Material(Shader.Find("Custom/Subsurface/TransparentGlossNMSeparateAlphaComputeBuff"));
					genMaterialIndex = i;
					skin.GPUmaterials[i] = genMaterial;
				} else {
					skin.GPUmaterials[i] = new Material(Shader.Find("Custom/Discard"));
				}
			}
			
			skin.FlushBuffers();
		};

		newCharacterContainer.SetActive(true);

		while(skin == null){
			skin = newCharacterContainer.GetComponentInChildren<DAZMergedSkinV2>();
			yield return null;
		}
		
		skin.name = "FutaSkin";
		newCharacterContainer.SetActive(false);
		
		
		
		SetMaleTransformsActive(false);
	
		characterSelector.selectedCharacter = newCharacter;
		characterRun.morphBank3 = characterSelector.maleMorphBank2;
		characterRun.morphBank3.connectedMesh = null;
		characterRun.ResetMorphs();	
		
		characterSelector.maleMorphBank2.gameObject.SetActive(true);
		
		SetMaleTransformsActive(true);
		
		
		// Set up Material Options 
		while(genMaterial == null){
			yield return null;
		}
		
		var dummyRenderer = newCharacterContainer.AddComponent<MeshRenderer>();
		//dummyRenderer.enabled = false;
		dummyRenderer.sharedMaterials = new Material[1];
		dummyRenderer.sharedMaterials[0] = genMaterial;
		
		genMaterialOptions = newCharacterContainer.AddComponent<MaterialOptionsWrapper>();
		
		genMaterialOptions.textureGroup1 = new MaterialOptionTextureGroup();
		genMaterialOptions.SetCustomTextureFolder("Custom/Atom/Person/Textures");
		
		

		genMaterialOptions.paramMaterialSlots = new int[]{genMaterialIndex};
		genMaterialOptions.textureGroup1.materialSlots = genMaterialOptions.paramMaterialSlots;
		
		genMaterialOptions.skin = skin;
		genMaterialOptions.materialForDefaults = genMaterial;
		genMaterialOptions.enabled = true;
		
		// Set up the UI
		
		
		// The material selction prefab doesn't do well with a layout,
		// so we're just going to remove it.
		while(scriptUI == null){
			if(this.UITransform != null){
				scriptUI = this.UITransform.GetComponentInChildren<MVRScriptUI>();
			}
			yield return null;
		}
		
		if(scriptUI == null){
			SuperController.LogMessage("Unable to load script UI.");
			yield break;
		}
		
		UnityEngine.UI.VerticalLayoutGroup layout = scriptUI.fullWidthUIContent.gameObject.GetComponent<UnityEngine.UI.VerticalLayoutGroup>();
		Destroy(layout);
		
		// Find a pre-existing material option UI to use as a template. 
		// Any would likely do...
		while( materialUIPrefab == null){
			foreach (GameObject go in Resources.FindObjectsOfTypeAll(typeof(GameObject)) as GameObject[]){
				if(go.name =="Mouth Materials") {
					materialUIPrefab = go;
					break;
				}
			}
			if(materialUIPrefab == null){
				yield return null;
			}
		}
		
		var matOptionsUI = UnityEngine.Object.Instantiate<Transform>(materialUIPrefab.transform);
		genMaterialOptions.SetUI(matOptionsUI);
		
		genMaterialOptions.SyncAllParameters();
		
		genMaterialOptions.InitUI();

		matOptionsUI.SetParent(scriptUI.fullWidthUIContent,false);
		scriptUI.fullWidthUIContent.gameObject.SetActive(true);
		matOptionsUI.gameObject.SetActive(true);
		
	}
	
	private string GetPathToObject(GameObject go){
		 if (go.transform.parent == null)
			 return "/" + go.name;
		 return GetPathToObject(go.transform.parent.gameObject) + "/" + go.name;
	}
	
	private void AdjustBone(DAZBone bone){
		if(!bone.morphOffsets.ContainsKey("AltFuta")){
			bone.SetBoneYOffset("AltFuta",genBoneYOffset);
			bone.SetBoneZOffset("AltFuta",genBoneZOffset);
			
			characterRun.morphBank3.bonesDirty = true;
		}
	}
	
	private void SetMaleTransformsActive(bool active){
		foreach(GameObject go in GetAllChildren(containingAtom.gameObject)){
			if(go.name.Contains("penis") && go.name.Contains("Control")){
				go.SetActive(active);
			}
			if(go.name == "Gen1"){
				go.SetActive(active);
			}
			if(go.name == "Gen2"){
				go.SetActive(active);
			}
			if(go.name == "Gen3"){
				go.SetActive(active);
			}
		}
	}
	
	private void Update(){
		if(characterRun.morphBank3 != null){
			AdjustBone(gen1Bone);
			AdjustBone(gen2Bone);
			AdjustBone(gen3Bone);
			
			if(characterRun.morphBank3 != characterSelector.maleMorphBank2){
				characterRun.morphBank3 = characterSelector.maleMorphBank2;
			}
			
			if(characterRun.morphBank3.connectedMesh != null){
				characterRun.morphBank3.connectedMesh = null;
			}
			
			
			if ( characterRun.morphBank3.bonesDirty)	{
				characterRun.bones.SetMorphedTransform(false);
				characterRun.morphBank3.bonesDirty = false;
			}
			if (characterRun.morphBank3.boneRotationsDirty != null)
			{
				foreach (var entry in characterRun.morphBank3.boneRotationsDirty){
					entry.Key.SyncMorphBoneRotations(false);
				}
				characterRun.morphBank3.boneRotationsDirty.Clear();
			}
		}
	}
	
	private void OnDestroy()
	{	
		if(maleCharacterContainer != null){
			DestroyImmediate(maleCharacterContainer);
		}
		if(newCharacterContainer != null){
			DestroyImmediate(newCharacterContainer);
		}
	}
		
	List<GameObject> GetAllChildren(GameObject parent, List<GameObject> objectList = null)
	{
		if (objectList == null) objectList = new List<GameObject>();
	  
		foreach (Transform child in parent.transform) {
			objectList.Add(child.gameObject);
			GetAllChildren(child.gameObject, objectList);
		}
		return objectList;
	}
	
	// Function taken from VAMDeluxe's code
	public static string GetPluginPath(MVRScript plugin, Atom atom){
		SuperController.singleton.currentSaveDir = SuperController.singleton.currentLoadDir;
		string pluginId = plugin.storeId.Split('_')[0];
		MVRPluginManager manager = atom.GetStorableByID("PluginManager") as MVRPluginManager;
		string pathToScriptFile = manager.GetJSON(true, true)["plugins"][pluginId].Value;
		string pathToScriptFolder = pathToScriptFile.Substring(0, pathToScriptFile.LastIndexOfAny(new char[] { '/', '\\' }));
		return pathToScriptFolder;
	}
}
}